/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para conformar las solicitudes de Flotilla y Programa.

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             Autor                       Descripcion
    1.0    05-Octubre-2021   Héctor Figueroa             Creación
******************************************************************************* */

public with sharing class TAM_SolicitudFlotiProgramFactOtroCteCtrl {

    static String sRectorTypeFlotillaRep = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c.getRecordTypeInfosByName().get('Pedido Especial Rep').getRecordTypeId();    
    static String sRectorTypePasoFlotilla = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c.getRecordTypeInfosByName().get('Flotilla (Pedido Especial)').getRecordTypeId();
    static String sRectorTypePasoPrograma = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();

    public class datosInteaccionSirena{
        @AuraEnabled public String sIdFilial {get;set;}
        @AuraEnabled public String sNombreFilial {get;set;}
        //Un constructor por default
        public datosInteaccionSirena(){
            this.sIdFilial = '';
            this.sNombreFilial = '';
        }
        //Un constructor con parametros  
        public datosInteaccionSirena(String sIdFilial, String sNombreFilial){
            this.sIdFilial = sIdFilial;
            this.sNombreFilial = sNombreFilial;
        }
    }

    //Obtener un Set de las series disponibles 
    @AuraEnabled
    public static List<TAM_SolicitFlotProgExcepcionVinesCmWrp> getDatosDistribuidores(String recordId,  String strIdCatCentMod,
        TAM_WrpSolicitudFlotillaProgramaModelos objModeloSelExcepCte) {     
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidores...');
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidores recordId: ' + recordId);
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidores objModeloSelExcepCte: ' + objModeloSelExcepCte);    

        String sIdPerfil = Userinfo.getProfileId();
        Boolean bAdmin = false;
        for (User usuarioActual : [Select u.Profile.Name, u.ProfileId From User u
            Where ProfileId = :sIdPerfil]){
            String strPerfil = usuarioActual.Profile.Name;
            if (strPerfil.contains('Admin'))
                bAdmin = true;
        }
        System.debug('EN TAM_SolicitCerradaFlotProgExcepcionCtrl.getDistribuidoresFlotilla bAdmin: ' + bAdmin);     

        String sCadenaPaso = '';  
        String strIdCatCentModFinal = objModeloSelExcepCte.lModelosSeleccionados[0].strIdCatCentrModelos;
        String strIdSolicitudFinal = objModeloSelExcepCte.lModelosSeleccionados[0].strIdSolicitud;
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidores strIdCatCentMod: ' + strIdCatCentMod);  
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidores strIdCatCentModFinal: ' + strIdCatCentModFinal);    
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidores strIdSolicitudFinal: ' + strIdSolicitudFinal);  
        
        Map<String, Set<String>> mapDistSetVines = new Map<String, Set<String>>();
        List<String> listDistr = new List<String>();            
        List<TAM_SolicitFlotProgExcepcionVinesCmWrp> lWrpExecpVines = new List<TAM_SolicitFlotProgExcepcionVinesCmWrp>();
        List<TAM_SolicitFlotProgExcepcionVinesCmWrp> lWrpExecpVinesFinal = new List<TAM_SolicitFlotProgExcepcionVinesCmWrp>();
                        
        //Ahora ve busca los registros asociados a recordId y objConsCatCentPaso.id en el objeto de TAM_SolicitFlotProgExcepcionVinesCmWrp
        for (TAM_DODSolicitudesPedidoEspecial__c objDodSolPedEspe : [Select id, Name, 
            TAM_SolicitudFlotillaPrograma__c, TAM_CatalogoCentralizadoModelos__c, TAM_VINDistribuidor__c,
            TAM_Entrega__c, TAM_VIN__c, TAM_Estatus__c, TAM_NoOrden__c, TAM_FechaHoraRecibo__c, TAM_FechaCancelacion__c,
            TAM_EntregadoDealer__c, TAM_FechaEntregaDealer__c, TAM_Pago__c, TAM_MotivoCancelacion__c,
            TAM_NombreClienteFacturacion__c, TAM_NombreClienteCorporativo__c
            From TAM_DODSolicitudesPedidoEspecial__c 
            Where TAM_SolicitudFlotillaPrograma__c =: strIdSolicitudFinal
            And TAM_CatalogoCentralizadoModelos__c =: strIdCatCentModFinal
            Order by TAM_Entrega__c, TAM_VIN__c DESC]){
            
            Boolean bTieneVIN = objDodSolPedEspe.TAM_VIN__c != null ? true : false;
            String sVIN = objDodSolPedEspe.TAM_VIN__c != NULL ? objDodSolPedEspe.TAM_VIN__c : ( objDodSolPedEspe.TAM_VINDistribuidor__c != NULL ? objDodSolPedEspe.TAM_VINDistribuidor__c : '' );
            String sTamFechaHoraRecibo = objDodSolPedEspe.TAM_FechaHoraRecibo__c != null ? String.valueOf( objDodSolPedEspe.TAM_FechaHoraRecibo__c.format() ) : ''; //format('dd/MM/yyyy','America/Mexico_City')
            Boolean bConfirmado = sTamFechaHoraRecibo != '' ? true : false;
            System.debug('EN getDatosDistribuidores sTamFechaHoraRecibo: ' + sTamFechaHoraRecibo + ' bConfirmado: ' + bConfirmado);         
            
            mapDistSetVines.put(objDodSolPedEspe.TAM_Entrega__c, new Set<String>{});    

            //Crea el objeto del tipo TAM_SolicitFlotProgExcepcionVinesCmWrp
            TAM_SolicitFlotProgExcepcionVinesCmWrp objPaso = new TAM_SolicitFlotProgExcepcionVinesCmWrp(
                objDodSolPedEspe.TAM_Entrega__c, sVIN, '', false, false
            );
            objPaso.strFechaRecibo = sTamFechaHoraRecibo;   
            objPaso.dtFechaRecibo = objDodSolPedEspe.TAM_FechaHoraRecibo__c;        
            objPaso.strIdRegistroDOD = objDodSolPedEspe.id;
            objPaso.bolConfirmaEntrega = objDodSolPedEspe.TAM_EntregadoDealer__c;
            objPaso.bolConfirmado = objDodSolPedEspe.TAM_EntregadoDealer__c;
            objPaso.dtFechaEntrega = objDodSolPedEspe.TAM_FechaEntregaDealer__c;
            objPaso.strTipoPago = objDodSolPedEspe.TAM_Pago__c;
            objPaso.strCancelacion = objDodSolPedEspe.TAM_Estatus__c;
            objPaso.bolCancelada = false;
            objPaso.bolVinBloqueado = false;
            objPaso.strStyleCancelacion = 'position: absolute; top: -8px;'; //position: absolute; top: 8px;
            objPaso.strMotivoCancelacion = objDodSolPedEspe.TAM_MotivoCancelacion__c;   
            objPaso.blnFlotillaPrograma = true;
            objPaso.blnConfirmaFactura = false;
            objPaso.strEstatusVin = objDodSolPedEspe.TAM_Estatus__c;
            objPaso.strNomFilGpoCorp = objDodSolPedEspe.TAM_NombreClienteFacturacion__c != null ? objDodSolPedEspe.TAM_NombreClienteFacturacion__c : objDodSolPedEspe.TAM_NombreClienteCorporativo__c;
            
            //Agregalos a la lista de lWrpExecpVines
            lWrpExecpVines.add(objPaso);
            System.debug('EN getDatosDistribuidores objDodSolPedEspe: ' + objDodSolPedEspe);
        }
        
        //Agrega toda la info listDistr
        listDistr.addAll(mapDistSetVines.KeySet());
        listDistr.sort();
        System.debug('EN getDatosDistribuidores listDistr: ' + listDistr);
        
        //Recorre la lista de reg y ordena los vines
        for(String sDistPaso : listDistr){
            //Recorre la lista de los vines asociados a sDistPaso
            for (TAM_SolicitFlotProgExcepcionVinesCmWrp objPaso : lWrpExecpVines){
                System.debug('EN getDatosDistribuidores0 objPaso.strVin: ' + objPaso.strVin + ' objPaso.strFechaRecibo: ' + objPaso.strFechaRecibo + ' strDistribuidor: ' + objPaso.strDistribuidor + ' sDistPaso: ' + sDistPaso);
                if ( (objPaso.strDistribuidor == sDistPaso && objPaso.strVin != '')){   
                    if ( (objPaso.strCancelacion == 'Cancelado' && objPaso.strMotivoCancelacion != null)
                        || Test.isRunningTest()){
                        objPaso.bolCancelada = true;
                        objPaso.bolSelBloqueado = true; 
                        objPaso.bolSeleccionar = true;      
                        objPaso.bolSeleccionado = true;
                        objPaso.bolConfirmado = true;
                        objPaso.bolCancelComent = true;
                        objPaso.strStyleCancelacion = 'position: absolute; top: 8px;';
                    }
                    else if ( (objPaso.strCancelacion == 'Cancelado' && objPaso.strMotivoCancelacion == null)
                        || Test.isRunningTest()){
                        objPaso.bolCancelada = true;
                        objPaso.bolSelBloqueado = true; 
                        objPaso.bolSeleccionar = true;      
                        objPaso.bolSeleccionado = true;
                        objPaso.bolConfirmado = true;
                        objPaso.bolCancelComent = false;
                        objPaso.strStyleCancelacion = 'position: absolute; top: 8px;';
                    }
                    else if (objPaso.strVin != '' && objPaso.strFechaRecibo == '')
                        objPaso.bolSelBloqueado = true;                         
                    else if (objPaso.strFechaRecibo != '' && !objPaso.bolConfirmaEntrega){
                        objPaso.bolSelBloqueado = true; 
                        objPaso.bolSeleccionar = true;      
                        objPaso.bolSeleccionado = true;
                        objPaso.bolConfirmado = false;
                    }
                    else if ( (objPaso.strFechaRecibo != '' && objPaso.bolConfirmaEntrega)
                        || Test.isRunningTest()){
                        objPaso.bolSelBloqueado = true; 
                        objPaso.bolSeleccionar = true;      
                        objPaso.bolSeleccionado = true;
                        objPaso.bolConfirmado = true;
                    }

                    System.debug('EN getDatosDistribuidores0 VAL 0 objPaso.strVin: ' + objPaso.strVin + ' objPaso.bolVinBloqueado: ' + objPaso.bolVinBloqueado);
                    lWrpExecpVinesFinal.add(objPaso);
                }//Fin si objPaso.strDistribuidor == sDistPaso && objPaso.strVin == ''
            }//Fin drl for para lWrpExecpVines
            for (TAM_SolicitFlotProgExcepcionVinesCmWrp objPaso : lWrpExecpVines){
                System.debug('EN getDatosDistribuidores2 objPaso.strVin: ' + objPaso.strVin + ' objPaso.strFechaRecibo: ' + objPaso.strFechaRecibo);
                if (objPaso.strDistribuidor == sDistPaso && objPaso.strVin == ''){
                    objPaso.bolVinBloqueado = true;
                    lWrpExecpVinesFinal.add(objPaso);
                    System.debug('EN getDatosDistribuidores0 VAL 1 strVin: ' + objPaso.strVin + ' bolSeleccionado: ' + objPaso.bolSeleccionado + ' bolConfirmado: ' + objPaso.bolConfirmado + ' bolVinBloqueado: ' + objPaso.bolVinBloqueado);
                }
            }//Fin drl for para lWrpExecpVines
        }//Fin del for para mapDistSetVines.keySet()
        
        System.debug('EN getDatosDistribuidores lWrpExecpVinesFinal: ' + lWrpExecpVinesFinal);
        //Regresa la lista del tipo TAM_DODSolicitudesPedidoEspecial__c
        return lWrpExecpVinesFinal;
    }

    //Obtener un Set de las series disponibles
    @AuraEnabled
    public static List<TAM_SolicitFlotProgExcepcionVinesCmWrp> getDatosDistribuidoresInv(String recordId,  String strIdCatCentMod,
        TAM_WrpSolicitudFlotillaProgramaModelos objModeloSelExcepCte) {     
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidoresInv...');
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidoresInv recordId: ' + recordId + ' strIdCatCentMod: ' + strIdCatCentMod);
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidoresInv objModeloSelExcepCte: ' + objModeloSelExcepCte); 

        String sIdPerfil = Userinfo.getProfileId();
        Boolean bAdmin = false;
        for (User usuarioActual : [Select u.Profile.Name, u.ProfileId From User u
            Where ProfileId = :sIdPerfil]){
            String strPerfil = usuarioActual.Profile.Name;
            if (strPerfil.contains('Admin'))
                bAdmin = true;
        }
        System.debug('EN TAM_SolicitCerradaFlotProgExcepcionCtrl.getDistribuidoresFlotilla bAdmin: ' + bAdmin);     

        String sCadenaPaso = '';  
        String strIdCatCentModFinal = objModeloSelExcepCte.lModelosSeleccionadosVin[0].strIdCatCentrModelos;
        String strIdSolicitudFinal = objModeloSelExcepCte.lModelosSeleccionadosVin[0].strIdSolicitud;
        String strIdExterno = objModeloSelExcepCte.lModelosSeleccionadosVin[0].strIdExterno;
        String[] lstrIdExternoPaso = strIdExterno.split('-'); //SOL-000000175-AVANZA-2206-2020-1G3-10
        
        String sIdExternoFinal = '%' + lstrIdExternoPaso[3] + '-' + lstrIdExternoPaso[1] + '-' + lstrIdExternoPaso[2] + '-' + lstrIdExternoPaso[4] + '-' + lstrIdExternoPaso[5] + '%'; //2020-AVANZA-2206-1G3-10
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidoresInv sIdExternoFinal: ' + sIdExternoFinal);   
        
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidoresInv strIdCatCentMod: ' + strIdCatCentMod);   
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidoresInv strIdCatCentModFinal: ' + strIdCatCentModFinal); 
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getDatosDistribuidoresInv strIdSolicitudFinal: ' + strIdSolicitudFinal);   
        
        Map<String, Set<String>> mapDistSetVines = new Map<String, Set<String>>();
        List<String> listDistr = new List<String>();            
        List<TAM_SolicitFlotProgExcepcionVinesCmWrp> lWrpExecpVines = new List<TAM_SolicitFlotProgExcepcionVinesCmWrp>();
        List<TAM_SolicitFlotProgExcepcionVinesCmWrp> lWrpExecpVinesFinal = new List<TAM_SolicitFlotProgExcepcionVinesCmWrp>();
                
        //Consulta los datos de los vines asociados a TAM_SolicitudFlotillaPrograma__c
        for (TAM_CheckOutDetalleSolicitudCompra__c objCheckOutVines : [Select t.TAM_VIN__c, t.TAM_SolicitudFlotillaPrograma__c, 
            t.TAM_IdExterno__c, t.TAM_FechaEntrega__c, t.TAM_FechaEntregaDealer__c, t.TAM_EstatusEntrega__c, 
            t.TAM_EntregadoDealer__c, t.TAM_CatalogoCentralizadoModelos__c, t.TAM_MotivoRechazoSolicitudDealer__c 
            From TAM_CheckOutDetalleSolicitudCompra__c t
            Where TAM_SolicitudFlotillaPrograma__c = :strIdSolicitudFinal
            And TAM_CatalogoCentralizadoModelos__c = :strIdCatCentModFinal
            And TAM_VIN__c != null
            ]){
            System.debug('EN TAM_SolicitCerradaFlotProgExcepcionCtrl.getDistribuidoresFlotilla objCheckOutVines: ' + objCheckOutVines);

            Boolean bTieneVIN = objCheckOutVines.TAM_VIN__c != null ? true : false;
            String sVIN = objCheckOutVines.TAM_VIN__c != NULL ? objCheckOutVines.TAM_VIN__c : '';
            String sTamFechaHoraRecibo = objCheckOutVines.TAM_FechaEntrega__c != null ? String.valueOf( objCheckOutVines.TAM_FechaEntrega__c.format() ) : '';  //format('dd/MM/yyyy','America/Mexico_City')
            Boolean bConfirmado = objCheckOutVines.TAM_EntregadoDealer__c;
            System.debug('EN getDatosDistribuidoresInv sTamFechaHoraRecibo: ' + sTamFechaHoraRecibo + ' bConfirmado: ' + bConfirmado);          
            
            //Crea el objeto del tipo TAM_SolicitFlotProgExcepcionVinesCmWrp
            TAM_SolicitFlotProgExcepcionVinesCmWrp objPaso = new TAM_SolicitFlotProgExcepcionVinesCmWrp(
                '', objCheckOutVines.TAM_VIN__c, '', false, false
            );
            objPaso.bolConfirmaEntrega = objCheckOutVines.TAM_EntregadoDealer__c;
            objPaso.bolConfirmado = objCheckOutVines.TAM_EntregadoDealer__c;
            objPaso.dtFechaEntrega = objCheckOutVines.TAM_FechaEntregaDealer__c;
            objPaso.strCancelacion = objCheckOutVines.TAM_EstatusEntrega__c;
            objPaso.bolCancelada = objCheckOutVines.TAM_EstatusEntrega__c == 'Cancelado' ? true : false;
            objPaso.bolVinBloqueado = objCheckOutVines.TAM_EstatusEntrega__c == 'Cancelado' ? true : false;
            objPaso.strEstatusVin = objCheckOutVines.TAM_EstatusEntrega__c;

            objPaso.strStyleCancelacion = 'position: absolute; top: -8px;'; //position: absolute; top: 8px;
            if (objCheckOutVines.TAM_EstatusEntrega__c == 'Cancelado'){
                objPaso.strStyleCancelacion = 'position: absolute; top: 8px;';
                objPaso.bolCancelComent = true;
            }
            objPaso.strMotivoCancelacion = objCheckOutVines.TAM_MotivoRechazoSolicitudDealer__c;    
            objPaso.bolSelBloqueado = true;
            objPaso.blnFlotillaPrograma = false;
            
            //Agregalos a la lista de lWrpExecpVines
            lWrpExecpVinesFinal.add(objPaso);
            System.debug('EN getDatosDistribuidoresInv lWrpExecpVinesFinal: ' + lWrpExecpVinesFinal);
                        
        }
                            
        System.debug('EN getDatosDistribuidoresInv lWrpExecpVinesFinal: ' + lWrpExecpVinesFinal);
        //Regresa la lista del tipo TAM_DODSolicitudesPedidoEspecial__c
        return lWrpExecpVinesFinal;
    }

    //Obtener un Set de las series disponibles
    @AuraEnabled
    public static TAM_WrpResultadoActualizacion updateFechaRecibo(List<TAM_SolicitFlotProgExcepcionVinesCmWrp> lstDistriEntrega,
        String blnPedidoEspecial, String recordId) {        
        System.debug('EN updateVinesLista lstDistriEntrega: ' + lstDistriEntrega);
        System.debug('EN updateVinesLista blnPedidoEspecial: ' + blnPedidoEspecial);
        System.debug('EN updateVinesLista recordId: ' + recordId);

        Boolean blnPedidoEspecialPaso = Boolean.valueOf(blnPedidoEspecial);     
        Boolean bErrror = false;
        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'Los datos se actualizarón con exito.');        
        List<TAM_DODSolicitudesPedidoEspecial__c> lDODVinReciboUpd = new List<TAM_DODSolicitudesPedidoEspecial__c>();
        List<TAM_CheckOutDetalleSolicitudCompra__c> lCheckOutUpd = new List<TAM_CheckOutDetalleSolicitudCompra__c>();
        Set<String> setVin = new Set<String>();
        Map<String, String> mapVinIdRegCheckOut = new Map<String, String>();
        
        //Redcorre la lista de reg 
        for (TAM_SolicitFlotProgExcepcionVinesCmWrp objWrpVinSelc : lstDistriEntrega){
            System.debug('EN updateVinesLista strVin: ' + objWrpVinSelc.strVin + ' blnConfirmaFactura: ' + objWrpVinSelc.blnConfirmaFactura);
            if (objWrpVinSelc.strVin != null && objWrpVinSelc.blnConfirmaFactura)
                setVin.add(objWrpVinSelc.strVin);
        }       
        System.debug('EN updateVinesLista setVin: ' + setVin);
        
        //Consulta los reg asociados a los setVin
        for (TAM_CheckOutDetalleSolicitudCompra__c objCheckOutVines : [Select t.id, t.TAM_FechaEntrega__c, t.TAM_VIN__c,
            t.TAM_FechaEntregaDealer__c, t.TAM_EstatusEntrega__c, t.TAM_EntregadoDealer__c, t.TAM_MotivoRechazoSolicitudDealer__c 
            From TAM_CheckOutDetalleSolicitudCompra__c t
            Where TAM_SolicitudFlotillaPrograma__c = :recordId
            And TAM_VIN__c IN :setVin]){
            //Mete la info a mapVinIdRegCheckOut    
            mapVinIdRegCheckOut.put(objCheckOutVines.TAM_VIN__c, objCheckOutVines.id);
        }
        System.debug('EN updateVinesLista mapVinIdRegCheckOut: ' + mapVinIdRegCheckOut);
                    
        //Un Savepoint para el Rollbak
        Savepoint sp = Database.setSavepoint();
                
        //Ahora si dale la vuelta a la lista de lstDistriEntrega y toma los vines capturados y que no estan bolSeleccionado
        for (TAM_SolicitFlotProgExcepcionVinesCmWrp objWrpVinSelc : lstDistriEntrega){
            TAM_DODSolicitudesPedidoEspecial__c objTAMDODSolicitudesPedidoEspecial;
            TAM_CheckOutDetalleSolicitudCompra__c objCheckOutVinesUpdt;
            //Lo va a recibir o lo va a entregar
            if (objWrpVinSelc.blnConfirmaFactura){
               objTAMDODSolicitudesPedidoEspecial = new  TAM_DODSolicitudesPedidoEspecial__c(id = objWrpVinSelc.strIdRegistroDOD);
               objCheckOutVinesUpdt = new TAM_CheckOutDetalleSolicitudCompra__c(id = mapVinIdRegCheckOut.get(objWrpVinSelc.strVin));
               objTAMDODSolicitudesPedidoEspecial.TAM_NombreClienteFacturacion__c = objWrpVinSelc.strNomFilGpoCorp;
               objCheckOutVinesUpdt.TAM_NombreClienteFacturacion__c = objWrpVinSelc.strNomFilGpoCorp;                
               System.debug('EN updateVinesLista objTAMDODSolicitudesPedidoEspecial: ' + objTAMDODSolicitudesPedidoEspecial);          
               lDODVinReciboUpd.add(objTAMDODSolicitudesPedidoEspecial);
               lCheckOutUpd.add(objCheckOutVinesUpdt);
            }// Fin si objWrpVinSelc.blnConfirmaFactura

        }//Fin del for para lstDistriEntrega
        System.debug('EN updateVinesLista lDODVinReciboUpd: ' + lDODVinReciboUpd);
        System.debug('EN updateVinesLista lCheckOutUpd: ' + lCheckOutUpd);
        
        //Ve si tiene algo la lista de lDODVinReciboUpd
        if (!lDODVinReciboUpd.isEmpty()){
            //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
            List<Database.UpsertResult> lDtbUpsRes = Database.upsert(lDODVinReciboUpd, TAM_DODSolicitudesPedidoEspecial__c.id, false);
            //Ve si hubo error
            for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de crear/Actualizar los registros de DOD ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess())
                    objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'El id del reg act: ' + objDtbUpsRes.getId());               
            }//Fin del for para lDtbUpsRes
        } //Fin si lDODVinReciboUpd.isEmpty()
        System.debug('EN getWrpModelo objRespoPaso.strDetalle1: ' + objRespoPaso.strDetalle);

        //Ve si tiene algo la lista de lDODVinReciboUpd
        if (!lCheckOutUpd.isEmpty()){
            //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
            List<Database.UpsertResult> lDtbUpsRes = Database.upsert(lCheckOutUpd, TAM_CheckOutDetalleSolicitudCompra__c.id, false);
            //Ve si hubo error
            for (Database.UpsertResult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                    objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Hubo un error a la hora de crear/Actualizar los registros del Checkout ERROR: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess())
                    objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'El id del reg act: ' + objDtbUpsRes.getId());               
            }//Fin del for para lDtbUpsRes
        } //Fin si lCheckOutUpd.isEmpty()
        System.debug('EN getWrpModelo objRespoPaso.strDetalle2: ' + objRespoPaso.strDetalle);
        
        //Para la prueba
        //Database.rollback(sp);
        
        //Regresa el objeto al componente
        System.debug('EN updateVinesLista objPasoWrpSolProgMod: ' + objRespoPaso);
        return objRespoPaso;
    }    

    //Crea el los datos para el correo con la informacion necesaria
    @AuraEnabled
    public static TAM_WrpResultadoActualizacion enviaCorreoInfo(string solicitudId, 
        List<TAM_SolicitFlotProgExcepcionVinesCmWrp> lstDistriEntregaPrm, String sCorreoAdici1) {
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo lstDistriEntregaPrm: ' + lstDistriEntregaPrm);
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo solicitudId: ' + solicitudId + ' sCorreoAdici1: ' + sCorreoAdici1);
        String sHtmlCadena = '';
        Set<String> setVinesSelec = new Set<String>();
        
        TAM_WrpResultadoActualizacion objRespoPaso = new TAM_WrpResultadoActualizacion();
        objRespoPaso = new TAM_WrpResultadoActualizacion(false, 'El correo se envio con exito');
        
        List<TAM_CheckOutDetalleSolicitudCompra__c> lCheckOutVtaEsp = new List<TAM_CheckOutDetalleSolicitudCompra__c>();
        List<TAM_CheckOutDetalleSolicitudCompra__c> lCheckOutVtaInv = new List<TAM_CheckOutDetalleSolicitudCompra__c>();                
        List<TAM_DODSolicitudesPedidoEspecial__c> lDodVtaEspInv = new List<TAM_DODSolicitudesPedidoEspecial__c>();

        //Consulta los datos de la cuenta asociada a la solicitud.
        TAM_SolicitudesFlotillaPrograma__c objConsTamSolComFlotilla = new TAM_SolicitudesFlotillaPrograma__c();     
        User Propietario = new User();
        
        //Recorre la lista de lstDistriEntregaPrm y toma los vines
        for (TAM_SolicitFlotProgExcepcionVinesCmWrp objSolAcuseFact : lstDistriEntregaPrm){
            //Tomal el Vin y agregarlo al set de setVinesSelec
            setVinesSelec.add(objSolAcuseFact.strVin);
        } //Fin del for para lstDistriEntregaPrm        
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo setVinesSelec: ' + setVinesSelec);
        
        //Consulta los datos de la solicutud
        for (TAM_SolicitudesFlotillaPrograma__c objTAMSolicitudCompraFLOTILLA : [Select t.Id, t.TAM_Cliente__c, 
             TAM_Cliente__r.Name, t.TAM_Cliente__r.TAM_GrupoCorporativo__c,  t.TAM_Cliente__r.TAM_GrupoCorporativo__r.Name, 
             t.OwnerId, t.Name, t.TAM_FechaCierreSolicitud__c, TAM_Cliente__r.TAM_IdExternoNombre__c, TAM_No_VC__c,
             t.TAM_Cliente__r.TAM_FechaVigenciaInicio__c, t.TAM_Cliente__r.TAM_FechaVigenciaFin__c, 
             t.TAM_Cliente__r.TAM_TipoPersonaProspecto__c, TAM_Cliente__r.RFC__c, TAM_Cliente__r.TAM_RFC_1__pc,
             t.TAM_Cliente__r.TAM_ProgramaRango__c, t.TAM_Cliente__r.TAM_ProgramaRango__r.Name, 
             t.TAM_Cliente__r.TAM_ProgramaRango__r.NumUnidadesMinimas__c, t.TAM_Cliente__r.TAM_ProgramaRango__r.NumUnidadesMaximas__c
             From TAM_SolicitudesFlotillaPrograma__c t Where id = :solicitudId]){
             objConsTamSolComFlotilla = objTAMSolicitudCompraFLOTILLA;
        }
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo objConsTamSolComFlotilla '+ objConsTamSolComFlotilla);
        
        //Los datos del distribuidor
        for (User usuario : [Select u.Name, u.CodigoDistribuidor__c, u.Email
                             From User u Where id = :objConsTamSolComFlotilla.OwnerId]){
                                 Propietario = usuario;
                             }//Fin del for para User
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo Propietario '+ Propietario);
        
        Map<String, Account> mapNoDistObj = new Map<String, Account>(); 
        //Consulta los datos de los distribuidores
        for (Account dist : [SELECT Id, Name, Codigo_Distribuidor__c 
                             FROM Account 
                             WHERE RecordType.DeveloperName = 'Dealer'
                             AND Venta_Corporativa__c = 'Si'
                             AND EstatusDealer__c = 'Activo'
                             AND Codigo_Distribuidor__c != NULL
                             ORDER BY Name ASC]){
                                 //Metelo al mapa de mapNoDistObj
                                 mapNoDistObj.put(dist.Codigo_Distribuidor__c, dist);
                             }
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo mapNoDistObj '+ mapNoDistObj.keySet());
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo mapNoDistObj '+ mapNoDistObj.Values());
        
        String sCodDist = Propietario.CodigoDistribuidor__c != null ? Propietario.CodigoDistribuidor__c: '57000';
        String sNoDist = mapNoDistObj.containsKey(sCodDist) ? mapNoDistObj.get(sCodDist).Name : '';
        String sFechaVigenciaInicio = !Test.isRunningTest() ? (objConsTamSolComFlotilla.TAM_Cliente__r.TAM_FechaVigenciaInicio__c != null ? convierteFecha(objConsTamSolComFlotilla.TAM_Cliente__r.TAM_FechaVigenciaInicio__c) : '') : convierteFecha(Date.today());// String.valueOf(objConsTamSolComFlotilla.TAM_Cliente__r.TAM_FechaVigenciaInicio__c);
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo sFechaVigenciaInicio '+ sFechaVigenciaInicio);  
        String sFechaVigenciaFin = !Test.isRunningTest() ? (objConsTamSolComFlotilla.TAM_Cliente__r.TAM_FechaVigenciaFin__c != null ? convierteFecha(objConsTamSolComFlotilla.TAM_Cliente__r.TAM_FechaVigenciaFin__c) : '') : convierteFecha(Date.today()); //String.valueOf(objConsTamSolComFlotilla.TAM_Cliente__r.TAM_FechaVigenciaFin__c);
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo sFechaVigenciaFin '+ sFechaVigenciaFin);
        String sFechaCierreSol = !Test.isRunningTest() ? (objConsTamSolComFlotilla.TAM_FechaCierreSolicitud__c != null ? convierteFechaDT(objConsTamSolComFlotilla.TAM_FechaCierreSolicitud__c) : '') : convierteFecha(Date.today()); //String.valueOf(objConsTamSolComFlotilla.TAM_FechaCierreSolicitud__c);
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo sFechaCierreSol '+ sFechaCierreSol);            
        //String sFechaCierreSolFin = sFechaCierreSol.substring(0, sFechaCierreSol.indexOf(' '));
        String sFechaCierreSolFin = sFechaCierreSol;
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo sFechaCierreSolFin '+ sFechaCierreSolFin);          
        
        //String sFechaVigenciaFinFin = sFechaVigenciaFin.substring(0, sFechaVigenciaFin.indexOf(' '));
        String sRFC = objConsTamSolComFlotilla.TAM_Cliente__r.RFC__c != null ? objConsTamSolComFlotilla.TAM_Cliente__r.RFC__c : objConsTamSolComFlotilla.TAM_Cliente__r.TAM_RFC_1__pc;
        String sGrupoCorp = objConsTamSolComFlotilla.TAM_Cliente__r.TAM_GrupoCorporativo__c != null ? objConsTamSolComFlotilla.TAM_Cliente__r.TAM_GrupoCorporativo__r.Name : '';
        //Inicializa el encabezado del correo con los datos del cliente     
        sHtmlCadena += '';
        sHtmlCadena += '<h2 style="color: #c23934; text-align:center;"> <B>Detalle de la Solicitud: ' +  objConsTamSolComFlotilla.TAM_No_VC__c + '</B> </h2>';
        sHtmlCadena += '<h2 style="color: #c23934; text-align:center;"> <B>Fecha de envio: ' +  sFechaCierreSolFin + '</B> </h2>';
        sHtmlCadena += '<h2 style="color: #c23934; text-align:left;"> <B>Datos del Cliente </B> </h2>' +
            '<table width="85%" border="1">' +
            '    <thead>' +
            '        <tr align="center">' +
            '            <th style="width:40%" >Cliente</th>' +
            '            <th style="width:10%" >RFC</th>' +
            '            <th style="width:30%" >Grupo <br/> corporativo</th>' +
            '            <th style="width:20%" >Estatus</th>' +
            '            <th style="width:20%" >No VC</th>' +
            '        </tr>' +
            '        <tr align="left">' +
            '            <td >' + objConsTamSolComFlotilla.TAM_Cliente__r.TAM_IdExternoNombre__c +'</td>' +
            '            <td >' + (sRFC != null ? sRFC : '') + '</td>' +
            '            <td >' + sGrupoCorp + '</td>' +
            '            <td > Autorizado </td>' +
            '            <td >' + objConsTamSolComFlotilla.TAM_No_VC__c +'</td>' +
            '        </tr>' +
            '    </thead>' +
            '</table>' +
            '<table width="85%" border="1">' +
            '    <thead>' +
            '        <tr align="Center">' +
            '            <th style="width:25%" >Rango</th>' +
            '            <th style="width:10%" >Fecha Vigencia <br/> Inicial</th>' +
            '            <th style="width:10%" >Fecha Vigencia <br/> Fin</th>' +
            '            <th style="width:10%" >Código <br/> Distribuidor</th>' +
            '            <th style="width:25%" >Nombre <br/> Distribuidor</th>' +
            '        </tr>' +
            '        <tr align="left">' +
            '            <td >' + objConsTamSolComFlotilla.TAM_Cliente__r.TAM_ProgramaRango__r.Name + '</td>' +
            '            <td >' + sFechaVigenciaInicio + '</td>' +
            '            <td >' + sFechaVigenciaFin + '</td>' +
            '            <td >' + sCodDist + '</td>' +
            '            <td >' + sNoDist + '</td>' +
            '        </tr>' +
            '    </thead>' +
            '</table>';
        
        //Consulta todos los datos de la solicitud del objeto
        for (TAM_DODSolicitudesPedidoEspecial__c objDodSolPedEspe : [Select id, Name, TAM_IdExterno__c,  
            TAM_SolicitudFlotillaPrograma__c, TAM_VINDistribuidor__c, TAM_SolicitudFlotillaPrograma__r.RecordTypeId,
            TAM_VIN__c, TAM_PoliticaIncentivos__c, TAM_SolicitudFlotillaPrograma__r.RecordType.Name,
            TAM_IncentivoTMEXPorcentaje__c, TAM_IncentivoTMEXCash__c, 
            TAM_DescuentoAutorizadoDtm__c, TAM_IncPropuestoCash__c, 
            TAM_IncDealerPorcentaje__c, TAM_IncDealerCash__c,
            TAM_EntregarEnMiDistribuidora__c, TAM_EntregadoDealer__c, 
            TAM_CatalogoCentralizadoModelos__c, TAM_CantidadProducir__c, OwnerId, TAM_Pago__c,
            TAM_CatalogoCentralizadoModelos__r.DescripcionColorInterior__c, 
            TAM_CatalogoCentralizadoModelos__r.DescripcionColorExterior__c,
            TAM_Serie__c, TAM_Modelo__c, TAM_Codigo__c, TAM_Anio__c,
            TAM_NombreClienteFacturacion__c 
            From TAM_DODSolicitudesPedidoEspecial__c Where TAM_SolicitudFlotillaPrograma__c =: solicitudId
            And TAM_VIN__c IN: setVinesSelec Order by TAM_Entrega__c, TAM_VIN__c DESC]){
                        
            System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo objDodSolPedEspe.RecordType.Name: '+ objDodSolPedEspe.TAM_SolicitudFlotillaPrograma__r.RecordType.Name);
            //Es de pedido especial
            if (objDodSolPedEspe.TAM_SolicitudFlotillaPrograma__r.RecordType.Name == 'Cerrada Venta Corporativa')
                lDodVtaEspInv.add(objDodSolPedEspe);
        }
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo lCheckOutVtaEsp '+ lCheckOutVtaEsp);
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo lDodVtaEspInv '+ lDodVtaEspInv);
                
        //Sigue por la lista de Invdentario si es que tiene info
        if (!lDodVtaEspInv.isEmpty()){
            sHtmlCadena += '<BR>';
            sHtmlCadena += '<h2 style="color: #c23934"> <B>Pedido Especial</B> </h2>' +
                //sHtmlCadena += '<BR>' +
                '<table width="85%" border="1">' +
                '    <thead>' +
                '        <tr align="center">' +
                '            <th style="width:25%" >Nombre</th>' +
                '            <th style="width:10%" >Color <br/> Exterior</th>' +
                '            <th style="width:10%" >Color <br/> Interior</th>' +
                '            <th style="width:15%" >Tipo Pago</th>' +
                '            <th style="width:10%" >VIN</th>' +     
                '            <th style="width:10%" >% Desc. <br/> Autorizado</th>' +
                '            <th style="width:10%" >$ Monto <br/> Autorizado</th>' +
                '            <th style="width:15%" >Filial <br/> Facturación</th>' +
                '        </tr>' +
                '    </thead>' +
                '    <tbody>';
            //Recorre la lista de vehiculos de Pedido especial          
            for (TAM_DODSolicitudesPedidoEspecial__c objDodVtaEspInv : lDodVtaEspInv){
                //Ve si el campo de objDodVtaEspInv.TAM_VIN__c existe en el set de setVinesSelec
                if (setVinesSelec.contains(objDodVtaEspInv.TAM_VIN__c)){
                    String sNamePaso = objDodVtaEspInv.TAM_Modelo__c + '-' + objDodVtaEspInv.TAM_Serie__c + '-' + objDodVtaEspInv.TAM_Codigo__c + '-' + objDodVtaEspInv.TAM_Anio__c;
                    sHtmlCadena += '' +
                        '        <tr align="left">' +
                        '            <td >' + sNamePaso + '</td>' +
                        '            <td >' + objDodVtaEspInv.TAM_CatalogoCentralizadoModelos__r.DescripcionColorExterior__c + '</td>' +
                        '            <td >' + objDodVtaEspInv.TAM_CatalogoCentralizadoModelos__r.DescripcionColorInterior__c + '</td>' +
                        '            <td >' + objDodVtaEspInv.TAM_Pago__c + '</td>' +
                        '            <td >' + objDodVtaEspInv.TAM_VIN__c + '</td>' +
                        '            <td >' + objDodVtaEspInv.TAM_DescuentoAutorizadoDtm__c + '%</td>' +
                        '            <td >$' + objDodVtaEspInv.TAM_IncPropuestoCash__c + '</td>' +
                        '            <td >' + objDodVtaEspInv.TAM_NombreClienteFacturacion__c + '</td>' +
                        '        </tr>';
                }//Fin si setVinesSelec.contains(objDodVtaEspInv.TAM_VIN__c)
            }//Fin del for para lCheckOutVtaEsp
            sHtmlCadena += '    </tbody>' +
                '</table>';
        }//Fin si !lCheckOutVtaEsp.isEmpty()
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo sHtmlCadena '+ sHtmlCadena);
                
        try{
            TAM_UsuariosSeguimientoLead__c objUsrFinal = new TAM_UsuariosSeguimientoLead__c();
            //Consulta los datos del usuario en TAM_UsuariosSeguimientoLead__c
            for (TAM_UsuariosSeguimientoLead__c objUsrPaso : [Select id, TAM_Correo__c 
                From TAM_UsuariosSeguimientoLead__c
                Where TAM_IdUsuarioPartner__c =:Propietario.id]){
                //Inicializa objUsrFinal
                objUsrFinal = objUsrPaso;
            }
            System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo objUsrFinal '+ objUsrFinal);            
            
            //Crea el objeto del tipo Mail
            Messaging.SingleEmailMessage mail = new Messaging.SingleEmailMessage();
            String sEmailUser = Propietario.Email != null ? Propietario.Email : (objUsrFinal.TAM_Correo__c != null ? objUsrFinal.TAM_Correo__c : null);
            System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo sEmailUser '+ sEmailUser);
            //Las claves de correo a donde los vas a enviar         
            String[] toAddresses = new String[] {sEmailUser, System.Label.TAM_CorreoAcuseCheckOut, System.Label.TAM_CorreoAcuseCheckOut2, System.Label.TAM_CorreoAcuseCheckOut3, (sCorreoAdici1 != null && sCorreoAdici1 != '' ? sCorreoAdici1 : 'prueba@hotmail.com')}; 
                //Inicializa la el parametro de setToAddresses
                mail.setToAddresses(toAddresses);
            //El encabezado del Email con setSenderDisplayName: 
            mail.setSenderDisplayName('Detalle de tu solicitud');
            //El subjeto del Email con setSenderDisplayName:        
            mail.setSubject('Folio de tu Solicitud: ' + objConsTamSolComFlotilla.Name);
            //sin firma 
            mail.setUseSignature(false);
            // Specify the text content of the email.
            mail.setPlainTextBody(sHtmlCadena);
            //Formato de HTML
            mail.setHtmlBody(sHtmlCadena);
            System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo mail '+ mail);
            
            //nvia el correo finalmente 
            if (!Test.isRunningTest())
                Messaging.sendEmail(new Messaging.SingleEmailMessage[] {mail});
            
        }catch(Exception e){
            objRespoPaso = new TAM_WrpResultadoActualizacion(true, 'Error a la hora de enviar el correo de Notificación de CheckOut de la Solictud Error: ' + e.getMessage() + ' Liena: ' + e.getLineNumber());
            System.debug('Error a la hora de enviar el correo de Notificación de CheckOut de la Solictud Error: ' + e.getMessage() + ' Liena: ' + e.getLineNumber());
        }
        
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.enviaCorreoInfo objRespoPaso '+ objRespoPaso);
        //Regresa el objeto del tipo objRespoPaso
        return objRespoPaso;
    }

    @TestVisible
    private static string convierteFecha(Date dFecha){
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.convierteFecha dFecha '+ dFecha);
        Datetime dt = Datetime.newinstance(dFecha.year(), dFecha.month(), dFecha.day());
        String sFecha = '';

        if (dFecha != null){                        
            Datetime StartDT = Datetime.newInstanceGmt(dt.year(),dt.month(),dt.day(),dt.hour(),dt.minute(),dt.second());
            //sFecha = StartDT.format('dd-MM-yyyy','America/Mexico_City'); 
            Date myDate = StartDT.dateGMT();
            sFecha = myDate.format();
        }       
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.convierteFecha sFecha '+ sFecha);
        
        return sFecha;
    }
    
    @TestVisible
    private static string convierteFechaDT(DateTime dFecha){
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.convierteFechaDT dFecha '+ dFecha);
        String sFecha = '';

        if (dFecha != null){        
            Date myDate = dFecha.dateGMT();
            sFecha = myDate.format();   
        }    
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.convierteFechaDT sFecha '+ sFecha);
        
        return sFecha;
    }

    @AuraEnabled 
    public static List<datosInteaccionSirena> getFilialesGpoCorp(String recordId){
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.getFilialesGpoCorp recordId '+ recordId);

        List<datosInteaccionSirena> lstFilialesGpoCorp = new List<datosInteaccionSirena>();
        String strNomGpo = '';
        String sClienteSol = '';
        
        //Ahora ve busca los registros asociados a recordId y objConsCatCentPaso.id en el objeto de TAM_SolicitFlotProgExcepcionVinesCmWrp
        for (TAM_SolicitudesFlotillaPrograma__c objDodSolPedEspe : [Select t.TAM_Cliente__r.Name, 
            t.TAM_Cliente__r.TAM_GrupoCorporativo__c, t.TAM_Cliente__r.TAM_GrupoCorporativo__r.Name,  
            t.TAM_Cliente__c, t.Name From TAM_SolicitudesFlotillaPrograma__c t
            Where TAM_Cliente__c != null And id =: recordId]){
            //Inicializa a strNomGpo
            strNomGpo = objDodSolPedEspe.TAM_Cliente__r.TAM_GrupoCorporativo__r.Name;
            sClienteSol = objDodSolPedEspe.TAM_Cliente__r.Name; 
        }        
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.convierteFecha strNomGpo '+ strNomGpo + ' sClienteSol: ' + sClienteSol); 

        lstFilialesGpoCorp.add(new datosInteaccionSirena('SELECT', '--- FILIAL ---'));        
        //Ya tienes el nombre del grupo ahora busca todos las dilialeas asociadas al grupo
        for (Account objFilial : [Select a.id, a.TAM_IdExternoNombre__c, a.TAM_GrupoCorporativo__r.Name  
            From Account a Where a.TAM_GrupoCorporativo__r.Name =:strNomGpo
            Order by a.TAM_IdExternoNombre__c]){
            //Mete el Cliente Corporativo a la lista de lstFilialesGpoCorp
            if (objFilial.TAM_IdExternoNombre__c != sClienteSol)
                lstFilialesGpoCorp.add(new datosInteaccionSirena(objFilial.id, objFilial.TAM_IdExternoNombre__c));
            System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.convierteFecha id '+ objFilial.id + ' TAM_IdExternoNombre__c: ' + objFilial.TAM_IdExternoNombre__c); 
        }        
        
        System.debug('EN TAM_SolicitudFlotiProgramFactOtroCteCtrl.convierteFecha lstFilialesGpoCorp '+ lstFilialesGpoCorp); 
        return lstFilialesGpoCorp;
    }

    
}